---
title: SourceBuffer.changeType()
slug: Web/API/SourceBuffer/changeType
tags:
  - API
  - Audio
  - MSE
  - Media
  - Media Source
  - Media Source Extensions
  - Method
  - Non-standard
  - SourceBuffer
  - Video
  - changeType
---
<div>{{APIRef("Media Source Extensions")}}{{SeeCompatTable}}{{Non-standard_Header}}</div>

<p><span class="seoSummary">The <code><strong>changeType()</strong></code> method of the {{domxref("SourceBuffer")}} interface sets the MIME type that future calls to {{domxref("SourceBuffer.appendBuffer", "appendBuffer()")}} should expect the new media data to conform to.</span> This makes it possible to change codecs or container type mid-stream.</p>

<p>One scenario in which this is helpful is to support adapting the media source to changing bandwidth availability, by transitioning from one codec to another as resource constraints change.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>sourceBuffer</em>.changeType(<em>type</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>type</code></dt>
 <dd>A {{domxref("DOMString")}} specifying the MIME type that future buffers will conform to.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref('undefined')}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>The specified string is empty, rather than indicating a valid MIME type.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>The {{domxref("SourceBuffer")}} is not a member of the parent media source's {{domxref("MediaSource.sourceBuffers", "sourceBuffers")}} list, or the buffer's {{domxref("SourceBuffer.updating", "updating")}} property indicates that a previously queued {{domxref("SourceBuffer.appendBuffer", "appendBuffer()")}} or {{domxref("SourceBuffer.remove", "remove()")}} is still being processed.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>The specified MIME type is not supported, or is not supported with the types of {{domxref("SourceBuffer")}} objects present in the {{domxref("MediaSource.sourceBuffers")}} list.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>If the parent {{domxref("MediaSource")}} is in its <code>"ended"</code> {{domxref("MediaSource.readyState", "readyState")}}, calling <code>changeType()</code> will transition the media source to the <code>"open"</code> <code>readyState</code> and fire a simple event named {{event("sourceopen")}} at the parent media source.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBuffer.changeType")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
